<?php

namespace Modules\St\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\St\Entities\bank;
use Modules\St\Entities\BankBranch;
use Modules\St\Entities\Country;
use Modules\St\Entities\District;
use Modules\St\Entities\GLPosting;
use Modules\St\Entities\SupplierContact;
use Modules\St\Entities\Suppliers;
use Modules\St\Entities\SupplierType;
use Modules\St\Entities\Town;

class SupplierController2 extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        return view('st::index');
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('st::create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('st::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('st::edit');
    }



    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        //
    }





    public function settings()
    {
        try {
            $country = Country::all();
            $district = District::all();
            $bank = bank::all();
            $bank_branch = BankBranch::all();
            $types = SupplierType::all();
            $gl_posting = GLPosting::all();
            $settings = [
                "country" => $country,
                "district" => $district,
                "bank" => $bank,
                "bankBranch" => $bank_branch,
                "types" => $types,
                "gl_posting" => $gl_posting
            ];
            $responseBody = $this->responseBody(true, "Settings", "all", $settings);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Settings", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function town($id)
    {
        try {
            $town = Town::where('district_foreign_id', '=', $id)->get();
            $settings = [
                "town" => $town,
            ];
            $responseBody = $this->responseBody(true, "Towns", "all", $settings);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Towns", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function save(Request $request)
    {
        try {
            $supplier_id = $request->get("supplier_id");
            $supplier_name = $request->get("supplier_name");
            $supplier_address = $request->get("supplier_address");
            $supplier_web = $request->get("supplier_web");
            $supplier_country = $request->get("supplier_country");
            $supplier_district = $request->get("supplier_district");
            $supplier_town = $request->get("supplier_town");
            $supplier_map = $request->get("supplier_map");
            $supplier_note = $request->get("supplier_note");
            $supplier_type = $request->get("supplier_type");
            $supplier_gl_posting = $request->get("supplier_gl_posting");
            $supplier_bank = $request->get("supplier_bank");
            $supplier_bankbranch = $request->get("supplier_bankbranch");
            $supplier_vat = $request->get("supplier_vat");
            $supplier_svat = $request->get("supplier_svat");
            $supplier_alert_credit_limit = $request->get("supplier_alert_credit_limit");
            $supplier_alert_credit_period = $request->get("supplier_alert_credit_period");
            $supplier_hold_credit_limit = $request->get("supplier_hold_credit_limit");
            $supplier_hold_credit_period = $request->get("supplier_hold_credit_period");
            $contacts = json_decode($request->get("contacts"));


            $supplier =  new Suppliers();
            $supplier->supplier_id = $this->isEmpty($supplier_id);
            $supplier->supplier_name = $this->isEmpty($supplier_name);
            $supplier->address = $this->isEmpty($supplier_address);
            $supplier->web_address = $this->isEmpty($supplier_web);
            $supplier->country_id = $this->isEmpty($supplier_country);
            $supplier->district_id = $this->isEmpty($supplier_district);
            $supplier->town_id = $this->isEmpty($supplier_town);
            $supplier->gmap = $this->isEmpty($supplier_map);
            $supplier->supplier_type_id = $this->isEmpty($supplier_type);
            $supplier->account_group_id = $this->isEmpty($supplier_gl_posting);
            $supplier->tax1_no = $this->isEmpty($supplier_vat);
            $supplier->tax2_no = $this->isEmpty($supplier_svat);
            $supplier->alert_credit_limit = $this->isEmpty($supplier_alert_credit_limit);
            $supplier->alert_credit_period = $this->isEmpty($supplier_alert_credit_period);
            $supplier->hold_credit_limit = $this->isEmpty($supplier_hold_credit_limit);
            $supplier->hold_credit_period = $this->isEmpty($supplier_hold_credit_period);
            $supplier->status_id = NULL;
            $supplier->notes = $this->isEmpty($supplier_note);
            $supplier->bank_id = $this->isEmpty($supplier_bank);
            $supplier->bank_branch_id = $this->isEmpty($supplier_bankbranch);
            $save = $supplier->save();

            if ($save) {
                foreach ($contacts as $cont) {
                    $contact = new SupplierContact();
                    $contact->supplier_foriegn_id = $supplier->supplier_id;
                    $contact->designation = $this->isEmpty($cont->designation);
                    $contact->email = $this->isEmpty($cont->email);
                    $contact->mobile = $this->isEmpty($cont->mobile);
                    $contact->fixed = $this->isEmpty($cont->fixed_mobile);
                    $contact->sms_alert = $this->isBoolean($cont->sms_alert);
                    $contact->email_alert = $this->isBoolean($cont->email_alert);
                    $contact->primary_contact = $this->isBoolean($cont->primary_alert);
                    $contact->save();
                }
            }

            $responseBody = $this->responseBody(true, "Supplier", "save", $contacts);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Supplier", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function update(Request $request, $id)
    {
        try {
            $contact_id = $request->get("contact_id");
            $supplier_name = $request->get("supplier_name");
            $supplier_address = $request->get("supplier_address");
            $supplier_web = $request->get("supplier_web");
            $supplier_country = $request->get("supplier_country");
            $supplier_district = $request->get("supplier_district");
            $supplier_town = $request->get("supplier_town");
            $supplier_map = $request->get("supplier_map");
            $supplier_note = $request->get("supplier_note");
            $supplier_type = $request->get("supplier_type");
            $supplier_gl_posting = $request->get("supplier_gl_posting");
            $supplier_bank = $request->get("supplier_bank");
            $supplier_bankbranch = $request->get("supplier_bankbranch");
            $supplier_vat = $request->get("supplier_vat");
            $supplier_svat = $request->get("supplier_svat");
            $supplier_alert_credit_limit = $request->get("supplier_alert_credit_limit");
            $supplier_alert_credit_period = $request->get("supplier_alert_credit_period");
            $supplier_hold_credit_limit = $request->get("supplier_hold_credit_limit");
            $supplier_hold_credit_period = $request->get("supplier_hold_credit_period");
            $contacts = json_decode($request->get("contacts"));


            $supplier =  Suppliers::find($id);
            //$supplier->supplier_id = $supplier_id;
            $supplier->supplier_name = $this->isEmpty($supplier_name);
            $supplier->address = $this->isEmpty($supplier_address);
            $supplier->web_address = $this->isEmpty($supplier_web);
            $supplier->country_id = $this->isEmpty($supplier_country);
            $supplier->district_id = $this->isEmpty($supplier_district);
            $supplier->town_id = $this->isEmpty($supplier_town);
            $supplier->gmap = $this->isEmpty($supplier_map);
            $supplier->supplier_type_id = $this->isEmpty($supplier_type);
            $supplier->account_group_id = $this->isEmpty($supplier_gl_posting);
            $supplier->tax1_no = $this->isEmpty($supplier_vat);
            $supplier->tax2_no = $this->isEmpty($supplier_svat);
            $supplier->alert_credit_limit = $this->isEmpty($supplier_alert_credit_limit);
            $supplier->alert_credit_period = $this->isEmpty($supplier_alert_credit_period);
            $supplier->hold_credit_limit = $this->isEmpty($supplier_hold_credit_limit);
            $supplier->hold_credit_period = $this->isEmpty($supplier_hold_credit_period);
            $supplier->status_id = NULL;
            $supplier->notes = $this->isEmpty($supplier_note);
            $supplier->bank_id = $this->isEmpty($supplier_bank);
            $supplier->bank_branch_id = $this->isEmpty($supplier_bankbranch);
            $update = $supplier->update();

            if ($update) {
                SupplierContact::where('supplier_foriegn_id', '=', $id)->delete();

                foreach ($contacts as $cont) {
                    $contact = new SupplierContact();
                    $contact->supplier_foriegn_id = $supplier->supplier_id;
                    $contact->designation = $this->isEmpty($cont->designation);
                    $contact->email = $this->isEmpty($cont->email);
                    $contact->mobile = $this->isEmpty($cont->mobile);
                    $contact->fixed = $this->isEmpty($cont->fixed_mobile);
                    $contact->sms_alert = $this->isBoolean($cont->sms_alert);
                    $contact->email_alert = $this->isBoolean($cont->email_alert);
                    $contact->primary_contact = $this->isBoolean($cont->primary_alert);
                    $contact->save();
                }
            }

            $responseBody = $this->responseBody(true, "Supplier", "updated", NULL);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Supplier", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    protected function isEmpty($val)
    {

        if ($val == "null") {
            return NULL;
        }
        return $val;
    }


    public function isDuplicate($id)
    {
        $supplier = Suppliers::find($id);
        if ($supplier) {
            return "true";
        }
        return "false";
    }



    protected function isBoolean($value)
    {

        if ($value == "true") {
            return true;
        }
        return false;
    }





    public function allSuppliers()
    {
        try {
            $suppliers = Suppliers::all();
            $responseBody = $this->responseBody(true, "Suppliers", "all", $suppliers);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Suppliers", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getSupplier($id)
    {
        try {
            $supplier = Suppliers::find($id);
            if ($supplier) {
                $contacts = SupplierContact::where('supplier_foriegn_id', '=', $supplier->supplier_id)->get();
                $supplier->contacts = $contacts;
            }
            $responseBody = $this->responseBody(true, "Supplier", "get", $supplier);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Supplier", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function delete($id)
    {
        try {
            $supplier = Suppliers::find($id);
            $delete = $supplier->delete();
            if ($delete) {
                SupplierContact::where('supplier_foriegn_id', '=', $id)->delete();
            }
            $responseBody = $this->responseBody(true, "Supplier", "deleted", $supplier);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "Supplier", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
