console.log('st_customer_attachment.js loading');
var customerid = '';

$(document).ready(function () {

    $('#myTable').DataTable({
        responsive: true,
        "order": [],
        "columns": [
          { "data": "thTitle" },
          { "data": "thView" },
          { "data": "thDownload" },
          { "data": "thDelete" },
        ],
    });
    getCustomer();

    $('#attachmentAddModal').on('hidden.bs.modal', function () {
        loadAttachment();
      })
});
function openModal() {

    $('#attachmentAddModal').modal('toggle');

}
function getCustomer(){
    $.ajax({
        type: "GET",
        url: "/st/customers/all",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                $('#auto-comp1').setData(response.data.result)
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}
function autoCompleteSelectedOption(input, data) {
    console.log(data.id);
    var customerid = data.id;

    // getSelectedCustomerName(data.id);
    setcustomerid(customerid);
}

function getSelectedCustomerName(id){
    $.ajax({
        type: "GET",
        url: "/st/SelectedCustomers/name/"+id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {

            var name=response.data.result['customer_name'];


            $('#txtName').text(name);
        },
        error: function (error) {
            console.log(error);

        },

    });
}
function setcustomerid(customerid) {

    getSelectedCustomerName(customerid);
    $('#customer_id').val(customerid);
    loadAttachment();
}
function loadAttachment() {
    //resetAttachment();
    $.ajax({
      type: "GET",
      url: "/st/CustomerAttachment/allFiles/" + $('#customer_id').val(),
      processData: false,
      contentType: false,
      cache: false,
      timeout: 800000,
      beforeSend: function () {

      },
      success: function (response) {
        console.log(response);
        if (response.data.success) {
          var data = [];
          for (i = 0; i < response.data.result.length; i++) {
            var title = response.data.result[i]['file_path'];
            var id = response.data.result[i]['id'];
            var file = "'" + title + "'";
            var string_id = "'" + id + "'";
            data.push({
              "thTitle": title,
              "thView": '<button class="btn btn-success" onclick="viewAttachment(' + file + ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
              "thDownload": '<button class="btn btn-primary" onclick="downloadAttachment(' + file + ')"><i class="fa fa-download" aria-hidden="true"></i></button>',
              "thDelete": '<button class="btn btn-danger" onclick="attachmentDelete(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
            });
          }


          var table = $('#myTable').DataTable();
          table.clear();
          table.rows.add(data).draw();

        } else {

        }

      },
      error: function (error) {
        console.log(error);

      },
      complete: function () {

      }
    });

}
function viewAttachment(file) {
    window.open('/customer/' + file);

}
function downloadAttachment(file) {

    var link = document.createElement("a");
    link.download = file;
    link.href = "/customer/" + file;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;

}
function attachmentDelete(attachment_id) {

    $.ajax({
      type: "GET",
      url: "/st/CustomerAttachment/delete/" + attachment_id,
      processData: false,
      contentType: false,
      cache: false,
      timeout: 800000,
      beforeSend: function () {

      },
      success: function (response) {
        console.log(response);
        if (response.data.success) {
          showSuccessMessage("Attachment has been deleted successfully...");
          loadAttachment();
        } else {
          showErrorMessage();
        }

      },
      error: function (error) {
        console.log(error);

      },
      complete: function () {

      }
    });
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
