const SAVE = "save";
const UPDATE = "update";

const TOWN = 'town';
const COUNTRY = 'country';
const DISTRICT = 'district';
const SUPPLIER_TYPE = 'supplierType';
const SUPPLIER_STATUS = 'supplierStatus';
const BANK = 'bank';
const BANK_BRANCH = 'bankBranch';

const TITLE_MAP = {
    'savecountry': 'Add new Country',
    'savedistrict': 'Add new District',
    'savetown': 'Add new Town',
    'savesupplierType': 'Add new Supplier Type',
    'savesupplierStatus': 'Add new Supplier Status',
    'savebank': 'Add new Bank',
    'savebankBranch': 'Add new Bank Branch',

    'updatecountry': 'Update Country',
    'updatedistrict': 'Update District',
    'updatetown': 'Update Town',
    'updatesupplierType': 'Update Supplier Type',
    'updatesupplierStatus': 'Update Supplier Status',
    'updatebank': 'Update Bank',
    'updatebankBranch': 'Update Bank Branch',
};

const URL_MAP = {
    'country': '/st/supplier/settings/country',
    'town': '/st/supplier/settings/town',
    'district': '/st/supplier/settings/district',
    'supplierType': '/st/supplier/settings/SupplierType',
    'supplierStatus': '/st/supplier/settings/SupplierStatus',
    'bank': '/st/supplier/settings/Bank',
    'bankBranch': '/st/supplier/settings/BankBranch',
};

const URL_MAP_SEARCH = {
    'country': '/st/supplier/settings/country',
    'town': '/st/supplier/settings/town',
    'district': '/st/supplier/settings/district',
    'supplierType': '/st/supplier/settings/SupplierType',
    'supplierStatus': '/st/supplier/settings/SupplierStatus',
    'bank': '/st/supplier/settings/Bank',
    'bankBranch': '/st/supplier/settings/BankBranch',
};

// This function is use to open a modal 
function showModal(event, name) {
    var title = TITLE_MAP[event + name];
    console.log(name);
    //console.log(event);
    if(name == TOWN) {       
        $('#selectDistrict').show();
        $('#lblDistrict').show();
        LoadDistrict_to_Town();
    } else {
        $('#selectDistrict').hide();
        $('#lblDistrict').hide();        
    }

    $('#txtSettingName').attr('name', name);
    $('#settingsAddModalTitle').text(title);

    if(event == SAVE) {
        $('#btnSetting').attr('name', 'save');
        $('#btnSetting').text('Save');
        $('#txtSettingName').val('');
    }
    if(event == UPDATE) {
        $('#btnSetting').attr('name', 'update');
        $('#btnSetting').text('Update');
        var evt = $('.table tbody').on('click', '.btn', function(event) {
            var currow = $(this).closest('tr');
            var id = currow.find('td:eq(0)').attr('id');
            var value = currow.find('td:eq(1)').text();
            $('#settingID').val(id);
            $('#txtSettingName').val(value);
            if (name == TOWN) {
                var town = currow.find('td:eq(2)').text();
                var district_id = currow.find('td:eq(1)').attr('id');
                console.log(district_id);
                $('#txtSettingName').val(town);
                $('#selectDistrict').attr('value', district_id);
            }
        });
    }

    $('#settingsAddModal').modal('toggle');
}

$('#btnSetting').on('click', function(event) {
    event.preventDefault();

    var key = $('#txtSettingName').attr('name');
    console.log(key);
    var url = URL_MAP[key];
    var _token = $("input[name='_token']").val();

    var evt = event.target.name;

    if(evt == SAVE) {
        var value = $('#txtSettingName').val();

        var form = new FormData();
        form.append("_token", _token);
        form.append("value", value);
        if (key == TOWN) {
            var district_id = $('#selectDistrict').val();
            form.append("district_id", district_id);
        }
        save(url, form);
    } else if (evt == UPDATE) {
        var id = $('#settingID').val();
        update(url, id);
    }
});

// save functions of settings 
function save(url, form) {
    console.log(url);
    $.ajax({
        type: 'POST',
        url: url,
        data: form,
        processData: false,
        contentType: false,
        cache: false,
        success: function (response) {
            console.log(response);
            $('#settingsAddModal').modal('hide');
            if(response){
                toastr.success('Record Added!');         
                GetSettings(response.data.name);
            }
        }, error: function(data) {
            console.log('Something went worng!');
         }
    });

}

// Update function of settings 
function update(url ,id) {
    $.ajax({
        type: 'PUT',
        url: url + '/' + id,
        data: $('#myForm').serialize(),
        success: function(response) {
            console.log(response);
            $('#settingsAddModal').modal('hide');
            GetSettings(response.data.name);
            if (response.data.success) {
                toastr.success('Record Updated!');
            }
        }, error: function(data) {
            console.log('Something went wrong!');
        }
    });
}

// Get Settings Function 
function GetSettings(key) {
    console.log(key);
    var url = URL_MAP_SEARCH[key];
    console.log(url);
    $.ajax({
        type: 'GET',
        url: url,
        processData: false,
        contentType: false,
        timeout: 800000,
        success: function(response) {
            console.log(response);

            if(response.data.success) {
                var name = response.data.name;
                var result = response.data.result;
                console.log(name);
                console.log(result);
                    LoadTable(name, result);
            } else {
                toastr.error('Something went wrong');
            }
        }, error: function(data) {
            console.log('Something went wrong!');
        }
    });
}

// Load Table function 
function LoadTable(name, result) {
    var disable = {0: "", 1: "checked"};
    var tbody = "";
    var tableName = "#tbl" + name;

    for (i = 0; i < result.length; i++) {

        var row = "<tr>";

        if (name == COUNTRY) {
            row += '<td id="' +result[i].country_id+ '">' +GenerateId(result[i].country_id)+ '</td>';
            row += '<td>' +result[i].country+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].country_id + '" onclick="showModal(' + "'update'" + ',' + "'country'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].country_id + '" onchange="disable(event,' + "'country'" + ')" ' + disable[result[i].status] + '>';
       
        } else if (name == DISTRICT) {
            row += '<td id="' +result[i].district_id+ '">' +GenerateId(result[i].district_id)+ '</td>';
            row += '<td>' +result[i].district+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].district_id + '" onclick="showModal(' + "'update'" + ',' + "'district'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].district_id + '" onchange="disable(event,' + "'district'" + ')" ' + disable[result[i].status] + '>';
       
        } else if (name == TOWN) {
            row += '<td id="' +result[i].town_id+ '">' +GenerateId(result[i].town_id)+ '</td>';
            row += '<td style="display:none;" id="' +result[i].district_foreign_id+ '">' +result[i].district_foreign_id+ '</td>';
            row += '<td>' +result[i].town+ '</td>';     
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].town_id + '" onclick="showModal(' + "'update'" + ',' + "'town'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].town_id + '" onchange="disable(event,' + "'town'" + ')" ' + disable[result[i].status] + '>';
    

        } else if (name == SUPPLIER_TYPE) {
            row += '<td id="' +result[i].supplier_type_id+ '">' +GenerateId(result[i].supplier_type_id)+ '</td>';
            row += '<td>' +result[i].supplier_type+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].supplier_type_id + '" onclick="showModal(' + "'update'" + ',' + "'supplierType'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].supplier_type_id + '" onchange="disable(event,' + "'supplierType'" + ')" ' + disable[result[i].status] + '>';
        
        } else if (name == SUPPLIER_STATUS) {
            row += '<td id="' +result[i].supplier_status_id+ '">' +GenerateId(result[i].supplier_status_id)+ '</td>';
            row += '<td>' +result[i].supplier_status+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].supplier_status_id + '" onclick="showModal(' + "'update'" + ',' + "'supplierStatus'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].supplier_status_id + '" onchange="disable(event,' + "'supplierStatus'" + ')" ' + disable[result[i].status] + '>';
        } else if (name == BANK) {
            row += '<td id="' +result[i].bank_id+ '">' +GenerateId(result[i].bank_id)+ '</td>';
            row += '<td>' +result[i].bank_name+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].bank_id + '" onclick="showModal(' + "'update'" + ',' + "'bank'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].bank_id + '" onchange="disable(event,' + "'bank'" + ')" ' + disable[result[i].status] + '>';
        } else if (name == BANK_BRANCH) {
            row += '<td id="' +result[i].bank_branch_id+ '">' +GenerateId(result[i].bank_branch_id)+ '</td>';
            row += '<td>' +result[i].bank_branch_name+ '</td>';
            row += '<td class="edit">';
            row += '<button type="button" class="btn btn-primary setting-edit-btn" id="' + result[i].bank_branch_id + '" onclick="showModal(' + "'update'" + ',' + "'bankBranch'" + ')">';
            row += '<i class="fa fa-pencil-square-o" aria-hidden="true"></button>';

            row += '</td>';
            row += '<td class="disable">';
            row += '<label class="switch">';
            row += '<input type="checkbox" id="' + result[i].bank_branch_id + '" onchange="disable(event,' + "'bankBranch'" + ')" ' + disable[result[i].status] + '>';
        }

        row += '<span class="slider round"></span>';
        row += '</label>';
        row += '</td>';
        row += '</tr>';
        tbody += row;
    }
    $(tableName).empty();
    $(tableName).append(tbody);
};

// Generate ID Function 
function GenerateId(id) {   
    let pattern = {
        1: "000",
        2: "00",
        3: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}

// This function is use for load district data in town add modal 
function LoadDistrict_to_Town() {
    var url = URL_MAP_SEARCH[DISTRICT];
    $.ajax({
        type: 'GET',
        url: url,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        success: function(response) {
            console.log(response);
            if (response.data.success) {

                var name = response.data.name;
                var result = response.data.result;
                $('#selectDistrict').empty();
                for (i = 0; i < result.length; i++) {
                    var district = result[i]['district'];
                    var id = result[i]['district_id'];
                    console.log(district);
                    console.log(id);
                    MakeDistrictElement(id , district);
                    var district1 = $('#selectDistrict').attr('value');
                    // alert(district1);
                    SetSelected_District_to_Town(district1);
                }
            }
        }, error: function(data) {
            console.log(data);
        }
    });
}

function MakeDistrictElement(id, district) {
    var element = '<option value="' +id+ '">' +district+ '</option>';
    $('#selectDistrict').append(element);
}

function SetSelected_District_to_Town(district1) {
    $("#selectDistrict").filter(function () {
        return $(this).val(district1);
    }).prop('selected', true);
}

// Disable function 
function disable(event, name) {
    var url = URL_MAP[name];
    var id = event.target.id;
    var status = event.target.checked;
    _delete(url, id, status);
}

function _delete(url, id, status) {
    var bool = 0;
    if (status) bool = 1;

    $.ajax({
        type: 'DELETE',
        url: url + '/' + id,
        data: {
            _token: $('input[name=_token]').val(),
            "status": bool
        },
        success: function(response) {
            console.log(response);
            if(response.data.result==1) {
                toastr.success('Data Activated');
            } else{
                toastr.error('Data Deactivated');
            }
        }, error: function(data) {
            console.log('Something went wrong!');
        }
    });

}